'  ##############
' # fbsound.bi #
'##############
' copyright D.J.Peters (Joshy)
' d.j.peters@web.de
' http://freebasic.eu

#ifndef __FBSOUND_BI__
#define __FBSOUND_BI__

#ifdef __FB_LINUX__
# inclib "fbsoundlin"
#else
# inclib "fbsoundwin"
#endif

#include "fbstypes.bi"
#include "fbscpu.bi"
#include "fbsmad.bi"
#include "fbsdsp.bi"

_DS FBS_RANDOMIZE              ()
_DF FBS_RND                    () as double
_DF FBS_Get_Keycode            () As FBS_KEYCODES

_DF FBS_Init                   (_B nRate      _AI=44100, _
                                _B nChannels  _AI=    2, _
                                _B nBuffers   _AI=    3, _
                                _B nFrames    _AI= 2048, _
                                _B index      _AI=   -1) _AB

' now fbs will start,stop and exit by it self
_DF FBS_Start                  () _AB
_DF FBS_Stop                   () _AB
_DF FBS_Exit                   () _AB

_DF FBS_Get_PlugPath           () _ASR
_DS FBS_Set_PlugPath           (_B NewPath _ASR)

_DF FBS_Get_NumOfPlugouts      () _AI
_DF FBS_Get_PlugName           () _ASR
_DF FBS_Get_PlugDevice         () _ASR
_DF FBS_Get_PlugError          () _ASR
_DF FBS_Get_PlugRate           () _AI ' 6000-96000
_DF FBS_Get_PlugBits           () _AI ' curently 16bit only
_DF FBS_Get_PlugChannels       () _AI ' 1=mono 2=stereo
_DF FBS_Get_PlugBuffers        () _AI ' 2 to N N<=64
_DF FBS_Get_PlugBuffersize     () _AI ' same as FrameSize*Frames
_DF FBS_Get_PlugFrames         () _AI ' same as BufferSize\FrameSize
_DF FBS_Get_PlugFramesize      () _AI ' same as BufferSize\Frames
_DF FBS_Get_PlugRunning        () _AB

_DF FBS_Get_PlayingSounds      () _AI
_DF FBS_Get_PlayingStreams     () _AI
_DF FBS_Get_PlayedBytes        () _AI
_DF FBS_Get_PlayedSamples      () _AI
_DF FBS_Get_PlayTime           () as DOUBLE


_DF FBS_Get_MasterVolume       (_B lpVolume _ASP) _AB
_DF FBS_Set_MasterVolume       (_B Volume   _AS ) _AB

_DF FBS_Set_MasterFilter       (_B nFilter _AI, _
                                _B Center  _AS, _
                                _B dB      _AS, _
                                _B Octave  _AS = 1.0, _
                                _B OnOff   _AB = True) _AB

_DF FBS_Enable_MasterFilter    (_B nFilter _AI) _AB
_DF FBS_Disable_MasterFilter   (_B nFilter _AI) _AB

_DS FBS_PitchShift             ( _B d _ASHP, _
                                 _B s _ASHP, _
                                 _B v _AS  , _
                                 _B n _AI  )

_DF FBS_Get_MaxChannels        (_B lpnChannels _AIP) _AB
_DF FBS_Set_MaxChannels        (_B nChannels   _AI ) _AB



_DF FBS_Set_MasterCallback     (_B lpCallback _ABC) _AB
_DF FBS_Enable_MasterCallback  ()                   _AB
_DF FBS_Disable_MasterCallback ()                   _AB

' create or load wave objects in the pool of Waves()

' create hWave from *.wav file
_DF FBS_Load_WAVFile           (_B Filename _ASR       , _
                                _B hWave    _AIP       ) _AB
' create hWave from *.mp3,*.mp2,*.mp file
_DF FBS_Load_MP3File           (_B Filename _ASR       , _
                                _B lphWave  _AIP       , _
                                _B tmpfile  _ASR =""   ) _AB
' create hWave with nSamples in memory
_DF FBS_Create_Wave            (_B nSamples _AI        , _
                                _B hWave    _AIP       , _
                                _B lpWave   _AAPP      ) _AB


' play any wave as sound from the pool of Waves()
' optional number of loops, playbackspeed,volume,pan
' if you need to change any param while playing use @hSound
_DF FBS_Play_Wave              (_B hWave    _AI        , _
                                _B nLoops   _AI  = 1   , _
                                _B Speed    _AS  = 1.0 , _
                                _B Volume   _AS  = 1.0 , _
                                _B Pan      _AS  = 0.0 , _
                                _B hSound   _AIP = NULL) _AB

'create an playable sound object "hSound" from any "hWave" object
_DF FBS_Create_Sound           (_B hWave    _AI        , _
                                _B lphSound _AIP = NULL) _AB


' [optinal] destroy/free created hSound's and hWave's
_DF FBS_Destroy_Wave           (_B lphWave  _AIP       ) _AB
_DF FBS_Destroy_Sound          (_B lphSound _AIP       ) _AB

' play an hSound object
_DF FBS_Play_Sound             (_B hSound   _AI        , _
                                _B nLoops   _AI = 1    ) _AB
' get and set any params from playing hSound
_DF FBS_Set_SoundSpeed         (_B hSound   _AI        , _
                                _B Speed    _AS=1.0    ) _AB
_DF FBS_Get_SoundSpeed         (_B hSound   _AI        , _
                                _B lpSpeed  _ASP       ) _AB

_DF FBS_Set_SoundVolume        (_B hSound   _AI        , _
                                _B Volume   _AS        ) _AB
_DF FBS_Get_SoundVolume        (_B hSound   _AI        , _
                                _B lpVolume _ASP       ) _AB

_DF FBS_Set_SoundPan           (_B hSound   _AI        , _
                                _B Pan      _AS=0.0    ) _AB
_DF FBS_Get_SoundPan           (_B hSound   _AI        , _
                                _B lpPan    _ASP       ) _AB

_DF FBS_Set_SoundLoops         (_B hSound   _AI        , _
                                _B nLoops   _AI=1      ) _AB
_DF FBS_Get_SoundLoops         (_B hSound   _AI        , _
                                _B lpnLoops _AIP       ) _AB
' togle hearing
_DF FBS_Set_SoundMuted         (_B hSound   _AI        , _
                                _B muted    _AB        ) _AB
_DF FBS_Get_SoundMuted         (_B hSound   _AI        , _
                                _B lpMuted  _ABP       ) _AB
' togle playing
_DF FBS_Set_SoundPaused        (_B hSound   _AI        , _
                                _B Paused   _AB        ) _AB
_DF FBS_Get_SoundPaused        (_B hSound   _AI        , _
                                _B lpPaused _ABP       ) _AB

_DF FBS_Get_SoundPointers      (_B hSound     _AI           , _
                                _B lpStart    _ASHPP = NULL , _
                                _B lpPlay     _ASHPP = NULL , _
                                _B lpEnd      _ASHPP = NULL , _
                                _B lpChannels _AIP   = NULL , _
                                _B lpSamples  _AIP   = NULL)  _AB

_DF FBS_Set_SoundCallback      (_B hSound     _AI      , _
                                _B lpCallback _ABC    )  _AB
_DF FBS_Enable_SoundCallback   (_B hSound     _AI      ) _AB
_DF FBS_Disable_SoundCallback  (_B hSound     _AI      ) _AB

' !!! OGG Vorbis FLAC and WAV are on the Todo list !!!

' create/play local MP3 stream
_DF FBS_Create_MP3Stream       (_B Filename   _ASR   ) _AB
_DF FBS_Play_MP3Stream         (_B Volume     _AS=1.0, _
                                _B Pan        _AS=0.0) _AB

_DF FBS_Set_StreamVolume       (_B Volume     _AS=1.0) _AB
_DF FBS_Get_StreamVolume       (_B Volume     _ASP   ) _AB
_DF FBS_Set_StreamPan          (_B Pan        _AS=0.0) _AB
_DF FBS_Get_StreamPan          (_B lpPan      _ASP   ) _AB

_DF FBS_Get_StreamBuffer       (_B lpBuffer   _ASHPP , _
                                _B lpChannels _AIP   , _
                                _B lpnSamples _AIP   ) _AB

_DF FBS_Set_StreamCallback     (_B lpCallback _ABC)  _AB
_DF FBS_Enable_StreamCallback  ()                     _AB
_DF FBS_Disable_StreamCallback ()                     _AB
' optional end an free an playing MP3 stream
_DF FBS_End_MP3Stream          () _AB




#endif ' __FBSOUND_BI__
