'  ###############
' # fbstypes.bi #
'###############
#ifndef __FBS_TYPES_BI__
#define __FBS_TYPES_BI__

'#define DEBUG

#ifdef DEBUG
# define dprint(msg) open err for output as #99:print #99,"debug: " & msg:close #99
#else
# define dprint(msg):
#endif

#ifndef NULL
# define NULL 0
#endif

#define _B byval
#define _R byref

#define _FU function
# define _DF declare _FU
# define _FUC _FU CDECL
# define _AFU as _FU
# define _AFUC as _FUC
#define _UF end _FU

#define _SU SUB
# define _DS declare _SU
# define _ASU as _SU
#define _US end _SU

#define _TY TYPE
#define _YT end _TY

#define _EN ENUM
#define _NE end _EN

# define _IF if
# define _EL else
# define _FI end _IF
# define _FO for
# define _OF next
# define _WH while
# define _HW wend
# define _SC select case
# define _CS end select

# define _TH then

#define _DA dim as
#define _CA cdecl alias

#define _BY BYTE
#define _BYP _BY PTR
#define _ABY AS _BY
#define _ABYP _ABY PTR
#define _UBY UBYTE
#define _UBYP _UBYP
#define _AUBY AS _UBY
#define _AUBYP _AUBY PTR

#define _SH SHORT
#define _SHP _SH PTR
#define _ASH AS _SH
#define _ASHP _ASH PTR
#define _ASHPP _ASHP PTR

#define _USH USHORT
#define _AUSH AS _USH
#define _AUSHP _AUSH PTR
#define _AUSHPP _AUSHP PTR

#define _AI AS INTEGER
#define _AIE _AI EXPORT
#define _AIP _AI PTR
#define _AIPP _AIP PTR
#define _AUI AS UINTEGER
#define _AUIP _AUI PTR
#define _ALI AS LONGINT
#define _ALIP _ALIP PTR

#define _DAI dim _AI
#define _DAS dim _AS


#ifndef BOOLEAN
_EN _BOOL
  false = 0
  true  = 1
_NE
_TY BOOLEAN _AI
#endif

#define _AB AS BOOLEAN
#define _ABP _AB PTR
#define _ABE _AB EXPORT

#define _AS AS SINGLE
#define _ASP _AS PTR
#define _ASE _AS EXPORT

#define _AD AS DOUBLE
#define _ADP _AD PTR
#define _ADE _AD EXPORT

#define _AA AS ANY
#define _AAP _AA PTR
#define _AAPP _AAP PTR

#define _ASR AS STRING
#define _ASRE _ASR EXPORT
#define _AZ AS ZSTRING
#define _AZP _AZ PTR

#define _RT RETURN TRUE
#define _TRT _TH _RT
#define _RF RETURN FALSE
#define _TRF _TH _RF
#define _TR _TH RETURN
#define _TES _TH exit _SU
#define _TEF _TH exit _FU




const WAVE_FORMAT_PCM _ASH = 1
_TY PCM_WAVEFORMAT
  _ASH  wFormatTag ' = WAVE_FORMAT_PCM
  _ASH  nChannels
  _AI   nRate
  _AI   nBytesPerSec
  _ASH  Framesize
  _ASH  nBits
_YT
const PCM_WAVEFORMAT_SIZE _AI = 16

_EN VCCs
  _RIFF = &H46464952
  _WAVE = &H45564157
  _fmt  = &H20746D66
  _data = &H61746164
_NE

_TY PCM_FILE_HDR field = 1
  ChunkRIFF         _AI     ' 4       Chunk_TY   'RIFF'
  ChunkRIFFSize     _AI     ' 8       ChunkSize
  ChunkID           _AI     '12       ChunkID     'WAVE'
  Chunkfmt          _AI     '16       Chunk_TY   'fmt '
  ChunkfmtSize      _AI     '20       ChunkSize

    wFormatTag      _ASH    '22  2
    nChannels       _ASH    '24  4
    nRate           _AI     '28  8
    nBytesPerSec    _AI     '32 12
    Framesize       _ASH    '34 14
    nBits           _ASH    '36 16

  Chunkdata         _AI     '40       Chunk_TY   'data'
  ChunkdataSize     _AI     '44       ChunkSize
_YT
const PCM_FILE_HDR_SIZE = 44
const PCM_FMT_SIZE = 16

_TY FBS_FORMAT_t
  _AI nRate
  _AI nBits
  _AI nChannels
  _AB signed
_YT
_TY FBS_FORMAT as FBS_FORMAT_t

_TY FBS_WAVE_t
  _ABYP lpStart
  _AI   nBytes
_YT
_TY FBS_WAVE as FBS_WAVE_t

_TY FBS_SAMPLE    _ASH
_TY MONO_SAMPLE   as FBS_SAMPLE
_TY STEREO_SAMPLE field=1
  as MONO_SAMPLE   l,r
_YT


_TY FillCallback       as _SU (byval lpArgs    _AI)
_TY FBS_BUFFERCALLBACK as _SU (byval lpSamples as FBS_SAMPLE ptr, _
                               byval nChannels _AI  , _ 
                               byval nSamples  _AI)

#ifndef _ABC
#define _ABC as FBS_BUFFERCALLBACK
#endif

_TY FBS_SOUND_t
  _ABC  Callback
  _AB   EnabledCallback
  _AIP  lphSound
  _ABYP lpStart
  _ABYP lpPlay
  _ABYP lpEnd
  _ABYP lpOrg
  _ABYP lpBuf
  _AI   nLoops 
  _AS   Speed
  _AS   Volume
  _AS   Pan
  _AS   lVolume
  _AS   rVolume
  _AB   usercontrol
  _AB   muted
  _AB   paused
_YT
_TY FBS_SOUND as FBS_SOUND_t

_EN FBS_KEYCODES 
  k_none            =   0 
  Ctrl_A            =   1 
  Ctrl_B            =   2 
  Ctrl_C            =   3 
  Ctrl_D            =   4 
  Ctrl_E            =   5 
  Ctrl_F            =   6 
  k_bell            =   7 
  k_backspace       =   8 
  k_tab             =   9 
  Ctrl_J            =  10 
  Ctrl_K            =  11 
  Ctrl_L            =  12 
  k_enter           =  13 
  Ctrl_N            =  14 
  Ctrl_O            =  15 
  Ctrl_P            =  16 
  Ctrl_Q            =  17 
  Ctrl_R            =  18 
  Ctrl_S            =  19 
  Ctrl_T            =  20 
  Ctrl_U            =  21 
  Ctrl_V            =  22 
  Ctrl_W            =  23 
  Ctrl_X            =  24 
  Ctrl_Y            =  25 
  Ctrl_Z            =  26 
  k_escape          =  27 
  Ctrl_5            =  29 
  Ctrl_6            =  30 
  Ctrl_7            =  31 
    
  k_space           =  32 
  k_exclamationmark =  33 ' ! 
  k_quote           =  34 ' " 
  k_hash            =  35 ' # 
  k_dollar          =  36 ' $ 
  k_percent         =  37 ' % 
  k_ampersand       =  38 ' & 
  k_singlequote     =  39 ' ' 
  k_leftbracket     =  40 ' ( 
  k_rightbracket    =  41 ' ) 
  k_multiply        =  42 ' * 
  k_plus            =  43 ' + 
  k_comma           =  44 ' , 
  k_minus           =  45 ' - 
  K_period          =  46 ' . 
  k_slash           =  47 ' / 

  k_0               =  48 
  k_1               =  49 
  k_2               =  50 
  k_3               =  51 
  k_4               =  52 
  k_5               =  53 
  k_6               =  54 
  k_7               =  55 
  k_8               =  56 
  k_9               =  57 

  k_colon           =  58 ' : 
  k_semicolon       =  59 ' ; 
  k_less            =  60 ' < 
  k_equals          =  61 ' = 
  k_greater         =  62 ' > 
  Shift_questionmark=  63 ' ? 
  AltGr_Q           =  64 ' @ 

  Shift_A           =  65 
  Shift_B           =  66 
  Shift_C           =  67 
  Shift_D           =  68 
  Shift_E           =  69 
  Shift_F           =  70 
  Shift_G           =  71 
  Shift_H           =  72 
  Shift_I           =  73 
  Shift_J           =  74 
  Shift_K           =  75 
  Shift_L           =  76 
  Shift_M           =  77 
  Shift_N           =  78 
  Shift_O           =  79 
  Shift_P           =  80 
  Shift_Q           =  81 
  Shift_R           =  82 
  Shift_S           =  83 
  Shift_T           =  84 
  Shift_U           =  85 
  Shift_V           =  86 
  Shift_W           =  87 
  Shift_X           =  88 
  Shift_Y           =  89 
  Shift_Z           =  90 

  k_L_square_bracket=  91 ' [ 
  k_Backslash       =  92 ' \ 
  k_R_square_bracket=  93 ' ] 
  k_Caret           =  94 ' ^ 
  k_underscore      =  95 ' _ 

  k_A               =  97 
  k_B               =  98 
  k_C               =  99 
  k_D               = 100 
  k_E               = 101 
  k_F               = 102 
  k_G               = 103 
  k_H               = 104 
  k_I               = 105 
  k_J               = 106 
  k_K               = 107 
  k_L               = 108 
  k_M               = 109 
  k_N               = 110 
  k_O               = 111 
  k_P               = 112 
  k_Q               = 113 
  k_R               = 114 
  k_S               = 115 
  k_T               = 116 
  k_U               = 117 
  k_V               = 118 
  k_W               = 119 
  k_X               = 120 
  k_Y               = 121 
  k_Z               = 122 

  k_L_curly_bracket = 123 ' { 
  k_R_curly_bracket = 125 ' } 
  k_Tilde           = 126 ' ~ 

  AltGr_C           = 162 '  

  AltGr_E           = 164 ' () 

  AltGr_Y           = 171 '  
  AltGr_6           = 172 

  AltGr_2           = 178 '  
  AltGr_3           = 179 '  

  AltGr_M           = 181 '  
  AltGr_R           = 182 
  AltGr_dot         = 183 '  

  AltGr_1           = 185 '  

  AltGr_X           = 187 '  

  Shift_ae          = 196 '  
  Shift_oe          = 214 '  
  Shift_ue          = 220 '  
  k_ss              = 223 '  
  k_ae              = 228 '  
  AltGr_A           = 230 '  

  AltGr_D           = 240 '  

  k_oe              = 246 '  
  
  AltGr_O           = 248 '  

  k_ue              = 252 '  

  AltGr_P           = 254 '  

  k_f1              = 315
  k_f2              = 316
  k_f3              = 317
  k_f4              = 318
  k_f5              = 319
  k_f6              = 320
  k_f7              = 321
  k_f8              = 322
  k_f9              = 323
  k_f10             = 324

  k_home            = 327
  K_up              = 328
  k_pageup          = 329
  k_left            = 331
  k_right           = 333
  k_end             = 335
  k_down            = 336
  k_pagedown        = 337
  k_insert          = 338
  k_delete          = 339
_NE

#endif ' __FBS_TYPES_BI__
