'  ###################
' # plugout-alsa02.bi #
'###################
#ifndef __FBS_PLUGOUT_ALSA__
#define __FBS_PLUGOUT_ALSA__
const EIO                          = -5  ' I/O error
const EAGAIN                       = -11 ' Try again
const EPIPE                        = -32 ' Broken pipe
const EBADFD                       = -77 ' File descriptor in bad state
const ESTRPIPE                     = -86 ' Streams pipe error

const BLOCK                        = 0
const NONBLOCK                     = 1
const ASYNC                        = 2

const SND_PCM_STREAM_PLAYBACK      = 0
const SND_PCM_STREAM_CAPTURE       = 1

_EN SND_PCM_FORMATS
  ' Signed 8 bit
  SND_PCM_FORMAT_S8 = 0
  ' Unsigned 8 bit
  SND_PCM_FORMAT_U8 = 1
  ' Signed 16 bit Little Endian 
  SND_PCM_FORMAT_S16_LE = 2
_NE

const SND_PCM_ACCESS_RW_INTERLEAVED= 3

_TY snd_pcm_t           _AAP
_TY snd_pcm_hw_params_t _AAP
_TY snd_pcm_sw_params_t _AAP

' PCM
_DF snd_strerror cdecl alias "snd_strerror" ( _
_B ecode _AI) _AZP

_DF snd_pcm_open cdecl alias "snd_pcm_open" ( _
_B pcm          as snd_pcm_t ptr, _
_B device       _ASR, _
_B direction    _AI, _
_B mode         _AI) _AI

_DF snd_pcm_hw_free cdecl alias "snd_pcm_hw_free" ( _
_B pcm          as snd_pcm_t) _AI

_DF snd_pcm_close cdecl alias "snd_pcm_close" ( _
_B pcm          as snd_pcm_t) _AI

_DF snd_pcm_start cdecl alias "snd_pcm_start" ( _
_B pcm          as snd_pcm_t) _AI

_DF snd_pcm_drain cdecl alias "snd_pcm_drain" ( _
_B pcm          as snd_pcm_t) _AI

_DF snd_pcm_nonblock cdecl alias "snd_pcm_nonblock" ( _
_B pcm          as snd_pcm_t, _
_B nonblock     _AI) _AI

_DF snd_pcm_prepare cdecl alias "snd_pcm_prepare" ( _
_B pcm          as snd_pcm_t) _AI

_DF snd_pcm_writei cdecl alias "snd_pcm_writei" ( _
_B pcm          as snd_pcm_t, _
_B buffer       _AAP, _
_B size         _AI) _AI

_DF snd_pcm_avail_update cdecl alias "snd_pcm_avail_update" ( _
_B pcm          as snd_pcm_t) _AI

_DF snd_pcm_wait cdecl alias "snd_pcm_wait" ( _
_B pcm          as snd_pcm_t, _
_B msec         _AI) _AI

_DF snd_pcm_resume cdecl alias "snd_pcm_resume" ( _
_B pcm          as snd_pcm_t) _AI

'hardware
_DF snd_pcm_hw_params_malloc cdecl alias "snd_pcm_hw_params_malloc" ( _
_B hw           as snd_pcm_hw_params_t ptr) _AI

_DF snd_pcm_hw_params_any cdecl alias "snd_pcm_hw_params_any" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t) _AI

_DF snd_pcm_hw_params_set_access cdecl alias "snd_pcm_hw_params_set_access" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t, _
_B mode         _AI) _AI

_DF snd_pcm_hw_params_set_format cdecl alias "snd_pcm_hw_params_set_format" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t, _
_B fmt          as SND_PCM_FORMATS) _AI

_DF snd_pcm_hw_params_set_channels cdecl alias "snd_pcm_hw_params_set_channels" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t, _
_B Channels     _AI) _AI

_DF snd_pcm_hw_params_get_channels cdecl alias "snd_pcm_hw_params_get_channels" ( _
_B hw           as snd_pcm_hw_params_t, _
_B lpChannels   _AIP) _AI

_DF snd_pcm_hw_params_set_rate_near cdecl alias "snd_pcm_hw_params_set_rate_near" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t, _
_B lpRate       _AIP, _
_B lpDir        _AIP) _AI

_DF snd_pcm_hw_params_get_periods cdecl alias "snd_pcm_hw_params_get_periods" ( _
_B hw           as snd_pcm_hw_params_t, _
_B lpValue      _AIP, _
_B lpDir        _AIP) _AI

_DF snd_pcm_hw_params_set_periods cdecl alias "snd_pcm_hw_params_set_periods" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t, _
_B Value        _AI, _
_B lpDir        _AI) _AI

_DF snd_pcm_hw_params_set_periods_near cdecl alias "snd_pcm_hw_params_set_periods_near" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t, _
_B lpValue      _AIP, _
_B lpDir        _AIP) _AI

_DF snd_pcm_hw_params_set_period_size cdecl alias "snd_pcm_hw_params_set_period_size" ( _
_B pcm          as snd_pcm_t, _
_B params       as snd_pcm_hw_params_t, _
_B nFrames      _AI, _
_B lpDir        _AIP) _AI

_DF snd_pcm_hw_params_get_period_size cdecl alias "snd_pcm_hw_params_get_period_size" ( _
_B params       as snd_pcm_hw_params_t, _
_B lpFrames     _AIP, _
_B lpDir        _AIP) _AI

'int  snd_pcm_hw_params_set_period_size_near (snd_pcm_t *pcm, snd_pcm_hw_params_t *params, snd_pcm_uframes_t *val, int *dir)
_DF snd_pcm_hw_params_set_period_size_near cdecl alias "snd_pcm_hw_params_set_period_size_near" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t, _
_B lpValue      _AIP, _
_B lpDir        _AIP) _AI

_DF snd_pcm_hw_params_set_buffer_size cdecl alias "snd_pcm_hw_params_set_buffer_size" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t, _
_B Frames      _AI) _AI

_DF snd_pcm_hw_params_set_buffer_size_near cdecl alias "snd_pcm_hw_params_set_buffer_size_near" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t, _
_B lpFrames     _AIP) _AI

_DF snd_pcm_hw_params_get_buffer_size cdecl alias "snd_pcm_hw_params_get_buffer_size" ( _
_B hw           as snd_pcm_hw_params_t, _
_B lpFrames     _AIP) _AI

_DF snd_pcm_hw_params cdecl alias "snd_pcm_hw_params" ( _
_B pcm          as snd_pcm_t, _
_B hw           as snd_pcm_hw_params_t) _AI

_DS snd_pcm_hw_params_free cdecl alias "snd_pcm_hw_params_free" ( _
_B hw           as snd_pcm_hw_params_t)

' software
_DF snd_pcm_sw_params_malloc cdecl alias "snd_pcm_sw_params_malloc" ( _
_B params       as snd_pcm_sw_params_t ptr) _AI

_DF snd_pcm_sw_params_current cdecl alias "snd_pcm_sw_params_current" ( _
_B pcm          as snd_pcm_t, _
_B params       as snd_pcm_sw_params_t ptr) _AI

_DF snd_pcm_sw_params_set_avail_min cdecl alias "snd_pcm_sw_params_set_avail_min" ( _
_B pcm          as snd_pcm_t, _
_B params       as snd_pcm_sw_params_t, _
_B value        _AI) _AI

_DF snd_pcm_sw_params_set_start_threshold cdecl alias "snd_pcm_sw_params_set_start_threshold" ( _
_B pcm          as snd_pcm_t,  _
_B params       as snd_pcm_sw_params_t, _
_B value        _AI) _AI

_DF snd_pcm_sw_params cdecl alias "snd_pcm_sw_params" ( _
_B pcm          as snd_pcm_t, _
_B params       as snd_pcm_sw_params_t) _AI

_DS snd_pcm_sw_params_free cdecl alias "snd_pcm_sw_params_free" ( _
_B params       as snd_pcm_sw_params_t)

#inclib "asound"
#endif '__FBS_PLUGOUT_ALSA__